// ThreadTest.cc
// -------------
// thread class test module
//                                               
// Design and Implementation by Bjoern Lemke               
//                                                         
// (C)opyright 2000 by Bjoern Lemke                        
//
//
///////////////////////////////////////////////////////////////////////////////

#include <unistd.h>
#include <pthread.h>

#include "Exception.h"
#include "Thread.h"
#include "ThreadLock.h"
#include "Chain.h"

#include "SigHandler.h"

static ThreadLock _lock;

class MyThread : public Thread
{
    
public:
    MyThread() : Thread() {
	
	_lock.init();
	
    }
    
    void* job(void* arg) {

	try {

	    int n = *(int*)arg;      
	    
	    int i=10;
	    while (i>0)
	    {
		_lock.writeLock(100123);
		
		cout << "Thread " << getTid() << " : Setting  x to " << i << endl;
		x = i;
		// sleep(1);
		
		_lock.unlock();
		i--;
	    }
	}
	catch (Exception e)
	{
	    e.print();
	    cout << "thread failed" << endl;
	}
	
	
    } 

private:
    
    int x;
    
    
};

int main(int argc, char **argv)
{
  
    try {    

	cout << "------------------------" << endl;
	cout << "Testing class Thread ..." << endl;
	cout << "   Constructors and Destructors...";
	if ( 1 )
	{
	    
	    MyThread myThread;
	    
	}
	
	cout << "ok" << endl;
	cout << "   Member methods...";
	
	MyThread myThread[100];
	
	int i, num[100], id[100];
	
	for (i=0; i<3; i++) 
	{
	    
	    // myThread.P(); // locking for argument synchronisation
	    
	    num[i]=i;
	    id[i] = myThread[i].start(&num[i]);
	    
	    cout << "Thread " << id[i] << " started" << endl;       
	    // sleep(1);
	    
	}
	
	
	// myThread.V();
	for (i=0; i<3; i++) 
	    myThread[i].join(id[i]);
	
	
	cout << "ok" << endl;
	
	cout << "------------------------" << endl;
	
	
    }
    catch (Exception e)
    {
	e.print();
	cout << "failed" << endl;
    }
    
}

  
