// ThreadTest.cc
// -------------
// thread class test module
//                                               
// Design and Implementation by Bjoern Lemke               
//                                                         
// (C)opyright 2000 by Bjoern Lemke                        
//
//
///////////////////////////////////////////////////////////////////////////////

#include <unistd.h>
#include <pthread.h>

#include "Exception.h"
#include "Thread.h"
#include "ThreadLock.h"
#include "Chain.h"

#include "NanoTimer.h"

#include "SigHandler.h"


static ThreadLock _lock;

class MyThread : public Thread
{
    
public:

    MyThread() : Thread() {
	
    }

    void setData(Chain *pData) {
	_pData = pData;
    }
    
    void* job(void* arg) {

	try {
	    

	    while (1)
	    {
		NanoTimer t;
		t.reset();
		
		int n = *(int*)arg;      
		
		t.start();
		
		
		int i=300000;

		while (i>0)
		{
		    
		    _lock.writeLock(100000);
		    
		    *_pData = Chain("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX");
		    
		    _lock.unlock();
		    
		    _lock.writeLock(100000);
		    
		    *_pData = Chain("YYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYY");
		    
		    _lock.unlock();
		    
		    i--;
		    
		}
		t.stop();
		
		cout << "Thread " << getTid() << " : " << t.getSum() / 1000000 << " msec" << endl;
		
	    }
	}
	catch (Exception e)
	{
	    e.print();
	    cout << "thread failed" << endl;
	}
       
    } 

private:
    
    Chain *_pData;
    
    
};


int main(int argc, char **argv)
{

    
    try {    


	Chain numThread(argv[1]);
	
	int nt = numThread.asInteger();


	Chain *pData = new Chain("XXXXXXXX");

	_lock.init(1000);
	
	MyThread myThread[nt];
	
	for (int i=0; i<nt; i++)
	{
	    myThread[i].setData(pData);
	} 
	
	int num[nt], id[nt];
	
	for (int i=0; i<nt; i++) 
	{
	   	    
	    num[i]=i;
	    id[i] = myThread[i].start(&num[i]);
	    
	    cout << "Thread " << id[i] << " started" << endl;       
	    
	}

	for (int i=0; i<nt; i++) 
	    myThread[i].join(id[i]);
	
	
	cout << "ok" << endl;
	
	cout << "------------------------" << endl;
	
	
    }
    catch (Exception e)
    {
	e.print();
	cout << "failed" << endl;
    }
    
}

  
