///////////////////////////////////////////////////////////////////////////////
// 
// TreeTest.cc - Testing the SetT template
//                                                         
// Design and Implementation by Bjoern Lemke               
//                                                         
// (C)opyright 2000-2006 by Bjoern Lemke                        
//
// IMPLEMENTATION MODULE
//
// Description: Testing the TreeT class
//
///////////////////////////////////////////////////////////////////////////////

#pragma implementation "TreeT.h"

#include "Exception.h"
#include "TreeT.h"


ostream& operator << (ostream& s, TreeT<int>& x)
{

     int* pElement = x.First();
  
     s << "{";
     
     while (pElement)
     {      
	  s << *pElement ;
	  pElement = x.Next(); 
	  if (pElement)
	       s << ",";
     }
     s << "}";
     
     return s;
  
}

typedef TreeT<int> IntTree;


ostream& operator << (ostream& s, TreeT<IntTree>& x)
{
     TreeT<int>* pElement = x.First();
  
     s << "{";
     
     while (pElement)
     {
	  s << *pElement ;
	  pElement = x.Next(); 
	  if (pElement)
	       s << ",";
     }
     s << "}";
     
     return s;
     
}

int main(int argc, char **argv)
{


  try {

   
      cout << "------------------------" << endl;
      cout << "Testing class TreeT ..." << endl;
      cout << "   Constructors and Destructors...";
      if ( 1 )
      {
	  TreeT<int> t;
	  
      }

          
      cout << "ok" << endl;
      cout << "   Member methods...";
          
      srandom(time(0));
    

    
      TreeT<int> bTree;
    
      bTree.Insert(1);
      bTree.Insert(3);
      bTree.Insert(2);
      
      bTree.Insert(1);
   
      bTree.Size();

      unsigned long  count = 100;
      while (count)
      {	
	
	 int elem = random() % (100 * count);
	 
	 bTree.Insert(elem);
	 
	 if (( count % 30)  == 0)
	 {
	     bTree.Empty();
	 }
	 
	 count--;	
      }
    
      bTree.Size();
       
    
      int count1=10;
      int count2=30;

      TreeT<IntTree> *powerTree = new TreeT<IntTree>;    
      unsigned long i = count1;
      
      while (i)
      {
	  TreeT<int> baseTree;
	  unsigned long j = count2;
	  
	  while (j)
	  {	
	      int elem = random() % count2;
	      baseTree.Insert(elem);
	      j--;	
	  }
	  
	  powerTree->Insert(baseTree);
	  i--;	
      }
      
      
      IntTree *p = powerTree->First();
      powerTree->Remove(*p);
      
      p = powerTree->First();      
      powerTree->Remove(*p);
     
      p = powerTree->First();
      powerTree->Remove(*p);

      
      cout << "ok" << endl;

      cout << "------------------------" << endl;
           
  }
  catch ( Exception e)
  {
      cout << "failed" << endl;
  }
  
          
}



