#ifndef _AESCRPYPT_H_INCLUDED_
#define _AESCRPYPT_H_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//                                                         
// AESCrypt.h
// ----------
// AES encryption class
//                                                         
// Design and Implementation by Bjoern Lemke               
//                                                         
// (C)opyright 2010 Bjoern Lemke                        
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; see the file COPYING.  If not, write to
// the Free Software Foundation, 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.
//
// INTERFACE MODULE
//
// Class: AESCrpyt
// 
// Description: 
//
// Status: IMPLEMENTED
///////////////////////////////////////////////////////////////////////////////

// INCLUDES
#include "Chain.h"

class AESCrypt {

public:
  
    AESCrypt();
    AESCrypt(const Chain& key, int keyLen);
    ~AESCrypt();

    Chain encrypt(const Chain& val);
        
    // AESCrypt& operator = ( const AESCrypt& cy);
    // bool operator == ( const AESCrypt& cy) const;
    
private:
    
    // int _keyLen;    
    // Chain _keyString;

    unsigned char getSBoxValue(int num);
    unsigned char getRconValue(int num);
    
    void KeyExpansion();
    void AddRoundKey(int round);
    void SubBytes();
    void ShiftRows();
    void MixColumns();
    void Cipher();
    unsigned char xtime(unsigned char x);
    
    int _Nr;
    int _Nk;
    
    // in - it is the array that holds the plain text to be encrypted.
    // out - it is the array that holds the output CipherText after encryption.
    // state - the array that holds the intermediate results during encryption.
    unsigned char _in[16], _out[16], _state[4][4];
    
    // The array that stores the round keys.
    unsigned char _RoundKey[240];
    
    // The Key input to the AES Program
    unsigned char _Key[32];
    
    
};



#endif



