#ifndef _BITMAP_H_INCLUDED_
#define _BITMAP_H_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//                                                         
// Bitmap.h
// --------
// Bitmap class definition
//                                                         
// Design and Implementation by Bjoern Lemke               
//                                                         
// (C)opyright 2000-2005 Bjoern Lemke                        
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; see the file COPYING.  If not, write to
// the Free Software Foundation, 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.
//
// INTERFACE MODULE
//
// Class: Bitmap
// 
// Description: This class provides bitmap management for boolean data
//
// Status: IMPLEMENTED
///////////////////////////////////////////////////////////////////////////////


// INCLUDES

#include "Chain.h"

class Bitmap {

public:
    
    Bitmap(int size);
    ~Bitmap();
    
    void setValue(int pos, bool val);
    bool getValue(int pos) const;
   
    Chain toChain() const;

    Bitmap& operator = ( const Bitmap& bm);
    bool operator == ( const Bitmap& bm) const;
  
private:

    char *_pBM;
    int _size;
};



#endif



