#ifndef _COMMANDEXECUTER_H_INCLUDED_
#define _COMMANDEXECUTER_H_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//                                                         
// CommandExecuter.h  
// -----------------
// Executing commands via process forking 
//                                                        
// Design and Implementation by Bjoern Lemke               
//                                                         
// (C)opyright 2007 Bjoern Lemke                        
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; see the file COPYING.  If not, write to
// the Free Software Foundation, 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.
//
// INTERFACE MODULE
//
// Class: CommandExecuter
// 
// Description:
//
// Status: IMPLEMENTED
///////////////////////////////////////////////////////////////////////////////

// BASE INCLUDES
#include "Chain.h"
#include "ListT.h"
#include "SigHandler.h"


// DEFINES
#define DEFTIMEOUT 60 

class CommandExecuter  : public SigHandler {
    
public:
    
    CommandExecuter();
    ~CommandExecuter();
    
    int execute(const Chain& command, int timeout = DEFTIMEOUT);
    
private:

    void sigCatch(int sig);
    int _childPid;
};

#endif







