#ifndef _GETOPT_H_INCLUDED_
#define _GETOPT_H_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//                                                         
// GetOpt.h
// --------
// GetOpt class definition
//                                                         
// Design and Implementation by Bjoern Lemke               
//                                                         
// (C)opyright 2000-2005 Bjoern Lemke                        
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; see the file COPYING.  If not, write to
// the Free Software Foundation, 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.
//
// INTERFACE MODULE
//
// Class: GetOpt
// 
// Description: Handling arguments from the command line
//
// Status: IMPLEMENTED
///////////////////////////////////////////////////////////////////////////////


class GetOpt {

 public:

  GetOpt(int argc, char** argv, char *f);  
  ~GetOpt();
  
  int firstOpt();
  int nextOpt();
  char* getArg();

 private:

  int parseOpt();  
  bool isValidOption(int c);

  int _optPos;
  int _argc;
  char **_argv;
  char *_pF;
  char *_optArg;
};


#endif



