///////////////////////////////////////////////////////////////////////////////
//                                                         
// Host.cc
// -------
// Host class implementation
//                                               
// Design and Implementation by Bjoern Lemke               
//                                                         
// (C)opyright 2000-2005 Bjoern Lemke                        
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; see the file COPYING.  If not, write to
// the Free Software Foundation, 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.
//
// IMPLEMENTATION MODULE
//
// Class: Host
// 
// Description: all operations on network resources
//
// Status: IMPLEMENTED
///////////////////////////////////////////////////////////////////////////////

#ifdef HAVE_MINGW32
#include <winsock2.h>
static boolean wsaCalled = false;
#endif

// SYSTEM INCLUDES
#include <unistd.h>

// BASE INCLUDES
#include "Exception.h"
#include "Chain.h"

#include "Host.h"

#define MAX_HOSTNAMELEN 100

Host::Host()
{
#ifdef HAVE_MINGW32
    if ( wsaCalled == false )
    {
	WSADATA wsa;
	long rc;
	rc = WSAStartup(MAKEWORD(2,0), &wsa);
	wsaCalled = true;
    }
#endif
}

Host::~Host()
{
}

Chain Host::getName() const
{
    char buf[MAX_HOSTNAMELEN];

    if ( ::gethostname(buf, MAX_HOSTNAMELEN) == -1 )
	throw Exception(EXLOC, "gethostname system error");
    
    return Chain(buf);
}



