#ifndef _MATCHER_H_INCLUDED_
#define _MATCHER_H_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//                                                         
// Matcher.h
// --------
// Matcher class definition
//                                                         
// Design and Implementation by Bjoern Lemke               
//                                                         
// (C)opyright 2000-2005 Bjoern Lemke                        
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; see the file COPYING.  If not, write to
// the Free Software Foundation, 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.
//
// INTERFACE MODULE
//
// Class: Matcher 
// 
// Description:
//
// Status: IMPLEMENTED
///////////////////////////////////////////////////////////////////////////////


// INCLUDES
#include <iostream>
#include <sys/types.h>

#ifdef HAVE_MINGW32
#include "regex.h"
#else
#include <regex.h>
#endif

class Matcher {

public:
    
    Matcher(const Chain& exp);
    ~Matcher();
    
    void prepare();

    bool match(const Chain& str);
    
private:
    
    Chain _expr;
    regex_t _re;    
    bool _isPrepared;
};



#endif



