#ifndef _NANOTIMER_H_INCLUDED_
#define _NANOTIMER_H_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//                                                         
// NanoTimer.h
// -----------
// NanoTimer class definition
//                                                         
// Design and Implementation by Bjoern Lemke               
// 
// (C)opyright 2000-2007 Bjoern Lemke                        
//                                                         
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; see the file COPYING.  If not, write to
// the Free Software Foundation, 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.
//
// INTERFACE MODULE
//
// Class: NanoTimer 
// 
// Description: NanoTimer class for time measurement
//
// Status: IMPLEMENTED 
///////////////////////////////////////////////////////////////////////////////


// INCLUDES
#ifdef HAVE_MINGW32
#include <windows.h>
#else
#include <sys/time.h>
#endif

class NanoTimer {

public:
    
    NanoTimer();
    ~NanoTimer();
    void start();
    void stop();

    long getSum() const;
    void reset();
    
private:

#ifdef HAVE_MINGW32
    LONGLONG _start, _end, _sum, _freq; 
#else
    long long _start, _end, _sum;
#endif

};

#endif



