#ifndef _NETHANDLER_H_INCLUDED_
#define _NETHANDLER_H_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//                                                         
// NetHandler.h
// ------------
// Net handle for sending and receiving messages
//                                                         
// (C)opyright 2000-2007 Bjoern Lemke
//
// Design and Implementation by Bjoern Lemke               
//                                                         
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
//
// You should have received a copy of the GNU General Public License
// along with this program; see the file COPYING.  If not, write to
// the Free Software Foundation, 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.
//
// INTERFACE MODULE
//
// Class: NetHandler
// 
// Description: Net handle for sending and receiving messages
//
// Status: CLEAN
//
///////////////////////////////////////////////////////////////////////////////


#include "Chain.h"
#include "ListT.h"

class NetHandler {
    
public:
    
    NetHandler(int msgSize, int sizeInfoLen);
    NetHandler(int s, int msgSize, int sizeInfoLen);

    ~NetHandler();

    bool waitMsg(int ms);

    // void setSendTimeout(int ms);
    // void setRecvTimeout(int ms);

    int getSocket();
    
    void writeMsg();
    void readMsg();


    void sendAck();
    void sendNack();
    bool recvAck();

    void sendChar(char c);
    char recvChar();
    
    char* getMsg();
    int getMsgSize();

    void setMsg(char* msg, int size);

    void disconnect();
    
    NetHandler& operator = ( const NetHandler& nh);
    bool operator == ( const NetHandler& nh) const;

private:

    char* _msgBuf;
    int _msgBufSize;
    int _msgSize;
    int _sizeInfoLen;
    int _socket;
    
};

#endif
