///////////////////////////////////////////////////////////////////////////////
//                                                         
// Process.cc
// ----------
// Process class implementation
//                                               
// Design and Implementation by Bjoern Lemke               
//                                                         
// (C)opyright 2000-2007 Bjoern Lemke                        
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; see the file COPYING.  If not, write to
// the Free Software Foundation, 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.
//
// IMPLEMENTATION MODULE
//
// Class: Process
// 
// Description: all operations on network resources
//
// Status: IMPLEMENTED
///////////////////////////////////////////////////////////////////////////////

#ifndef _REENTRANT
#define _REENTRANT    /* basic 3-lines for threads */
#endif

#include "Process.h"

// SYSTEM INCLUDES

#include <unistd.h>
#include <string.h>
#include <errno.h>

#include "Exception.h"
#include "Chain.h"


Process::Process()
{
}

Process::~Process()
{
}

int Process::getPid() const
{
    int pid;
    if ( ( pid = ::getpid())  == -1 )
    {
	Chain msg = Chain("getpid system error : ") + Chain(strerror(errno));
	throw Exception(EXLOC, msg);
    }
    return pid;
}



