#ifndef _SHAREDMEMORY_H_INCLUDED_
#define _SHAREDMEMORY_H_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//                                                         
// SharedMemory.h
// --------------
// shared memory class definition
//                                                         
// Design and Implementation by Bjoern Lemke               
//                                                         
// (C)opyright 2000-2005 Bjoern Lemke                        
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; see the file COPYING.  If not, write to
// the Free Software Foundation, 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.
//
// INTERFACE MODULE
//
// Class: SharedMemory 
// 
// Description: all operations on system shared memory resources
//
// Status: IMPLEMENTED
///////////////////////////////////////////////////////////////////////////////

class SharedMemory {

public:

     SharedMemory(int key);
     ~SharedMemory();
     
     void create(unsigned long size, int shmflag = 0666);
     void destroy();

     void attach(int shmflag = 0666);
     void detach();
     
     int getId();
     void* getAddr();

     void printInfo();

private:     

     int _key;
     int _id;
     void* _addr;

};


#endif

