#ifndef _THREAD_H_INCLUDED_
#define _THREAD_H_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//                                                         
// Thread.h
// --------
// Thread class interface definition
//                                                         
// Design and Implementation by Bjoern Lemke               
//                                                         
// (C)opyright 2000-2005 Bjoern Lemke                        
//                                                         
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; see the file COPYING.  If not, write to
// the Free Software Foundation, 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.
//
// INTERFACE MODULE
//
// Class: Thread
// 
// Description: all operations on POSIX threads
//
// Status: IMPLEMENTED
///////////////////////////////////////////////////////////////////////////////

#ifndef _REENTRANT
#define _REENTRANT    /* basic 3-lines for threads */
#endif


class Thread 
{
    
public:
    Thread();
    ~Thread();
    
    long start(void *arg);
    void join(long tid);
    void cancel();
    
    void P();
    void V();
    
    long getTid() { return _tid; };

protected:
    
    virtual void* job(void *arg) = 0;
    
    void *getArg() { return _arg; }

private:
    
    static void* task(void *pThis);

    long _tid;    
    void *_arg;
};

#endif

