#ifndef _TIMER_H_INCLUDED_
#define _TIMER_H_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//                                                         
// Timer.h
// --------
// Timer class definition
//                                                         
// Design and Implementation by Bjoern Lemke               
// 
// (C)opyright 2000-2005 Bjoern Lemke                        
//                                                         
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; see the file COPYING.  If not, write to
// the Free Software Foundation, 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.
//
// INTERFACE MODULE
//
// Class: Timer 
// 
// Description: Timer class for time measurement
//
// Status: IMPLEMENTED 
///////////////////////////////////////////////////////////////////////////////


// INCLUDES
#include <sys/time.h>
#include "Chain.h"

class Timer {

public:
    
    
    Timer(int s = 6, int p = 6);
    ~Timer();
    void start();
    void stop();

    Chain getUsed() const;
    
    long getSumSec() const;
    long getSumUSec() const;

    void reset();

    friend ostream& operator << (ostream& s, const  Timer& t);
    
private:

    int _scale;
    int _precision;

    long _sec;
    long _usec;

    long _sumSec;
    long _sumUSec;
};

#endif



