#ifndef _TOKENIZER_H_INCLUDED_
#define _TOKENIZER_H_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//                                                         
// Tokenizer.h
// -----------
// Tokenizer class definition
//                                                         
// Design and Implementation by Bjoern Lemke               
//                                                         
// (C)opyright 2000-2005 Bjoern Lemke                        
//                                                         
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; see the file COPYING.  If not, write to
// the Free Software Foundation, 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.
//
// INTERFACE MODULE
//
// Class: Tokenizer
// 
// Description: splitting a string into tokens
//
// Status: IMPLEMENTED
///////////////////////////////////////////////////////////////////////////////


// INCLUDES

#include "Chain.h"


// CLASS DEFINITION

class Tokenizer {

 public:
    
    Tokenizer(const Chain& tokenStream, const Chain& sep, char esc = '\'');
    ~Tokenizer();
    
    bool nextToken(Chain& token);
    bool getTail(Chain& token);
    
    Tokenizer& operator = (const Tokenizer& t);
 
 private:

    Chain _tokenStream;
    Chain _sep;
    char _esc;

    int _lower;
    int _upper;
};



#endif



